/* ======================================================================
					C L A S E   V E C T O R
====================================================================== */	
#include <stdio.h>
#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

#include "vector.h"

template <class T>
almacen <T> :: almacen (int tam) 
{
   tamanyo=tam;
   array= new T [tamanyo];
   num_elementos=0;
   estado=VACIA;
}
template <class T>
void almacen <T> :: meter (T elemento) 
{ 
   if( estado!=LLENA)
   { 
       array[num_elementos]=elemento;
       num_elementos++;
   }
    else
    { 
    	cout << "*** COMPLETO ***"<< endl;
    	cout << "Valor: "<< elemento << " no introducido. Se perderá." << endl;
    	cout<< "----------------------------------------------------------" << endl;
    }

    if(num_elementos>=tamanyo)
    { 
       estado=LLENA;
       num_elementos=tamanyo; 
    }
    else 
       estado=OK; 
}

template <class T>
T almacen <T> :: sacar () 
{
   T elemento=0;

   if(estado!=VACIA) 
   {
      elemento=array[num_elementos];
      num_elementos--;
   }
   else
   { 
   		cout<<"*** VACIO ***" << endl;
   		cout<<"Imposible sacar más objetos del vector." << endl;
   		cout<<"--------------------------------------------" << endl;
   }

   if(num_elementos<=0)
   {
      estado=VACIA;
      num_elementos=0;
   }    
   else 
      estado=OK; 

   return elemento; 
}

template <class T>
void almacen <T> :: visualizar () 
{ 
   for (int i=0; i<tamanyo; i++)
   { 
        if(i<num_elementos)
        {
        	cout << array[i] <<" ";
        }
        else 
        	break;
   }
   printf(" \n"); 
}

template <class T> 
int almacen <T> :: numero_elementos() 
{
   return num_elementos; 
}

template <class T> 
estado_almacen almacen <T> :: leer_estado() 
{
   return estado; 
}

template <class T>
void almacen <T> :: redimensionar (int tam) 
{
   if(tam>tamanyo)
   {	
   		T *nuevo_array= new T[tam]; //Definicion vector temporal
   		
   		for(int i=0; i<num_elementos; i++)
   		{
   				nuevo_array[i]=array[i];
   		}
   		delete[] array;
   		array=nuevo_array;
   		
   		tamanyo=tam;   		
   		estado=OK;
   }
}

template <class T> 
void almacen <T> :: anadir_espacio(int tam)
{
	T *nuevo_array= new T[tamanyo+tam]; //Definicion vector temporal
   		
   	for(int i=0; i<num_elementos; i++)
   	{
   			nuevo_array[i]=array[i];
   	}
   	delete[] array;
   	array=nuevo_array;
   		
   	tamanyo=tamanyo+tam;   		
   	estado=OK;
}

template <class T> 
void almacen <T> :: ordenar()
{
	Quicksort(&array[0], 0, num_elementos-1, false);
}

template <class T> 	   
void almacen <T> :: ordenar_inv()
{
	Quicksort(&array[0], 0, num_elementos, true);
}

int colocar(int *v, int b, int t)
{
    int i;
    int pivote, valor_pivote;
    int temp;
 
    pivote = b;
    valor_pivote = v[pivote];
    for (i=b+1; i<=t; i++)
    {
        if (v[i] <= valor_pivote)
        {
                pivote++;    
                temp=v[i];
                v[i]=v[pivote];
                v[pivote]=temp;
 
        }
    }
    temp=v[b];
    v[b]=v[pivote];
    v[pivote]=temp;
    
    return pivote;
} 
 
int colocar2(int *v, int b, int t)
{
    int i;
    int pivote, valor_pivote;
    int temp;
 
    pivote = b;
    valor_pivote = v[pivote];
    for (i=b+1; i<=t; i++){
        if (v[i] > valor_pivote)
        {
                pivote++;    
                temp=v[i];
                v[i]=v[pivote];
                v[pivote]=temp;
 
        }
    }
    temp=v[b];
    v[b]=v[pivote];
    v[pivote]=temp;
    
    return pivote;
}  
 
void Quicksort(int* v, int b, int t, bool flag)
{
     int pivote;
     if(b < t)
     {
     	if(flag==true)
     	{
        	pivote=colocar2(v, b, t);
     	}
        else
        {
        	pivote=colocar(v, b, t);
        }
        Quicksort(v, b, pivote-1, flag);
        Quicksort(v, pivote+1, t, flag);
     }  
}